<?php if (!defined('VB_ENTRY')) die('Access denied.');

class usertoplist_Api_Main extends vB_Api
{

	public function customWidgetHtml()
	{
		global $vbulletin;

		$limit = 100;
		$max_length = 50;
		$date_begin = '2021-01-01';
		$date_end = '2021-05-30';


		$topChannels = vB_Api::instance('content_channel')->fetchTopLevelChannelIds();

		$checkChannels = array(
			$topChannels['forum'],
			$topChannels['blog'],
			$topChannels['groups'],
		);

		$channelContentType = vB_Types::instance()->getContentTypeID('vBForum_Channel');

		$gotforums = '';
		foreach ($checkChannels as $checkChannel)
		{
			$forums = $vbulletin->db->query_read("
				SELECT node.nodeid
				FROM " . TABLE_PREFIX . "node AS node
				INNER JOIN " . TABLE_PREFIX . "closure AS cl ON cl.parent = $checkChannel AND cl.child = node.nodeid
				WHERE node.contenttypeid = $channelContentType
				AND node.nodeid <> $checkChannel
			");
			while ($forum = $vbulletin->db->fetch_array($forums))
			{
				$gotforums .= ',' . $forum['nodeid'];
			}
		}

		$users = $vbulletin->db->query_read("
			SELECT u.*
			FROM ".TABLE_PREFIX."user u, ".TABLE_PREFIX."usergroup ug
			WHERE
			u.usergroupid IN ('2')
			AND
			u.usergroupid = ug.usergroupid
		");

		$html = '
		<table>
			<thead>
				<tr>
					<th>#</th>
					<th>Avatar</th>
					<th>Username</th>
					<th>Email</th>
					<th>Post(s)</th>
				</tr>
			</thead>
			<tbody>
		';

		$pc = array();

		while ($user = $vbulletin->db->fetch_array($users))
		{
			$starterCount = $vbulletin->db->query_first("
				SELECT COUNT(*) AS count
				FROM " . TABLE_PREFIX . "node AS thread, " . TABLE_PREFIX . "text AS text
				WHERE thread.userid = " . $user['userid'] . "

				AND
				thread.nodeid = text.nodeid

				AND thread.parentid IN (0$gotforums)
				AND thread.starter = thread.nodeid
				AND thread.publishdate IS NOT NULL
				AND thread.approved = 1
				AND thread.showpublished = 1
				AND thread.contenttypeid <> " . intval($channelContentType) . "

				AND
				length(text.rawtext) > ".$max_length."
				AND
				FROM_UNIXTIME(thread.publishdate,'%Y-%m-%d') >= '".$date_begin."'
				AND
				FROM_UNIXTIME(thread.publishdate,'%Y-%m-%d') <= '".$date_end."'
			");

			$replyCount = $vbulletin->db->query_first("
				SELECT COUNT(*) AS count
				FROM " . TABLE_PREFIX . "node AS post
				INNER JOIN " . TABLE_PREFIX . "node AS thread ON (thread.nodeid = post.parentid), " . TABLE_PREFIX . "text AS text
				WHERE post.userid = " . $user['userid'] . "

				AND
				thread.nodeid = text.nodeid

				AND thread.parentid IN (0$gotforums)
				AND thread.publishdate IS NOT NULL
				AND thread.approved = 1
				AND post.starter = thread.nodeid
				AND post.publishdate IS NOT NULL
				AND post.approved = 1
				AND post.showpublished = 1
				AND post.contenttypeid <> " . intval($channelContentType) . "

				AND
				length(text.rawtext) > ".$max_length."
				AND
				FROM_UNIXTIME(thread.publishdate,'%Y-%m-%d') >= '".$date_begin."'
				AND
				FROM_UNIXTIME(thread.publishdate,'%Y-%m-%d') <= '".$date_end."'
			");

			$totalPosts = (int) $starterCount['count'] + $replyCount['count'];

			if ($totalPosts != 0)
			{
				$pc[] = [
					'img' => '<img class="b-avatar--s" src="./core/image.php?userid='.$user['userid'].'" alt="'.$user['username'].'">',
					'linkname' => '<a href="member/'.$user['userid'].'-'.strtolower($user['username']).'">'.$user['username'].'</a>',
					'email' => $user['email'],
					'posts' => $user['posts'],
					'count' => $totalPosts,
				];
			}
		}

		usort($pc, function($b,$a){
    	return ($a['count'] - $b['count']);
		});

		$num = 1;

		foreach ($pc as $row) {
			if ($num <= $limit) {
				$html .= '
				<tr>
					<td>'.$num.'</td>
					<td>'.$row['img'].'</td>
					<td>'.$row['linkname'].'</td>
					<td>'.$row['email'].'</td>
					<td>'.$row['count'].'</td>
				</tr>';
				$num++;
			}
		}

		$html .= '
			</tbody>
		</table>';

		return ['html' => $html];
	}
}
